/**************************
	Maxthon Library
	By Neo101
	Version 1.0.1
**************************/

var MaxLib = {

	SETTINGS_FILE : 'Settings.ini',
	DEFAULT_SETTINGS_FILE : 'DefaultSettings.ini',
	INI_SECTION : 'settings',

	ERROR_ELEMENT_ID : 'message',
	ERROR_DISPLAY_TIME : 30, //seconds


	showScriptError : function(message, url, line){
		var d = new Date()
		var date = MaxLib.timeToString( d.getHours() )+':'+MaxLib.timeToString( d.getMinutes() )+':'+MaxLib.timeToString( d.getSeconds() )
		var errorMessage = 'Message: '+message+' Line: '+line+' URL: '+url+' Date: '+date
		external.get_tab(SECURITY_ID, external.cur_sel).window.status = errorMessage
	},

	
	writeSetting : function(key, data) {
		this.writeIni(this.SETTINGS_FILE, this.INI_SECTION, key, data+'')
	},
	
	
	readSetting : function(key, errorResponse) {
		if(errorResponse == null){
			errorResponse = ''
		}
		var returnValue = this.readIni(this.SETTINGS_FILE, this.INI_SECTION, key, 'error')
		if(returnValue == 'error') {
			var defaultFileValue = this.readIni(this.DEFAULT_SETTINGS_FILE, this.INI_SECTION, key, 'error')
			if(defaultFileValue == 'error'){
				return errorResponse
			}
			else {
				this.writeSetting(key, defaultFileValue)
				returnValue = defaultFileValue
			}
		}
		
		return returnValue
	},


	checkSettingsFile: function(){
		if( this.readFile(this.SETTINGS_FILE) != undefined && this.readFile(this.SETTINGS_FILE) != ''){
			return false
		}
		var defaultSettingsFileData = this.readFile(this.DEFAULT_SETTINGS_FILE)
		if(defaultSettingsFileData && defaultSettingsFileData != ''){
			this.writeFile(this.SETTINGS_FILE, defaultSettingsFileData)
		}
		return true
	},


	readIni : function(file, section, key, errorResponse){
		if(errorResponse == null){
			errorResponse = ''
		}
		return external.m2_readIni(SECURITY_ID, PLUGIN_NAME, file, section, key, errorResponse)
	},


	writeIni : function(file, section, key, data) {
		external.m2_writeIni(SECURITY_ID, PLUGIN_NAME, file, section, key, data+'')
	},
	
	
	readFile : function(filename) {
		return external.readFile(SECURITY_ID, PLUGIN_NAME, filename)
	},


	writeFile : function(filename, data) {
		external.writeFile(SECURITY_ID, PLUGIN_NAME, filename, data)
	},


	showError : function(message){
		if(document.getElementById( this.ERROR_ELEMENT_ID )){
			if(this.timer){
				clearTimeout(this.timer)
			}
			document.getElementById(this.ERROR_ELEMENT_ID).innerHTML = message
			document.getElementById(this.ERROR_ELEMENT_ID).style.display = ''
			this.timer = window.setTimeout(MaxLib.hideError, 
												this.ERROR_DISPLAY_TIME * 1000)
		}
		else{
			alert(message)
		}
	},
	
	
	hideError : function(){
		document.getElementById(MaxLib.ERROR_ELEMENT_ID).style.display = 'none'
	},

	
	timeToString : function(element, length){
		if(length == null){
			length = 1
		}
		while(element.toString().length <= length){
			element = '0' + element
		}
		return element
	}

}

var JSON = {
	objectToJSON : function(item){
		switch(item.constructor){
			case Boolean:
				return item.toString();
				break;
			case Number:
				return item.toString();
				break;
			case String:
				return "'" + escape(item) + "'"
				break;
			case Date:
				return Number(item).toString();
				break;
			case Array:
				var tempObj = new Array()
				for(var i=0;i<item.length;i++){
					tempObj[i] = this.objectToJSON(item[i])
				}
				return '[' + tempObj.join(",") + ']'
				break;
			case Object:
				var str=["{"];
				for(var item2 in item){
					if(item[item2] == undefined){
						continue
					}
					str.push("'" + item2 + "' :")
					if(item2 == 'username' || item2 == 'password'){
						str.push("'" + appData.encodeTxt( item[item2] ) +"'")
					} else {
						str.push(this.objectToJSON( item[item2] ))
					}
					str.push(",")
				}
				//str=str.replace(/,$/,'')
				var pop = str.pop() // removes last ,
				if(pop != ','){
					str.push(pop)
				}
				str.push('}\n')
				return str.join('');
				break;
			default:
				return "''";
				break;
		}
	}
}

window.onerror = MaxLib.showScriptError