/*************************************************************
	Unofficial McAfee SiteAdvisor button for Google Search
	Maxthon Toolbar Button Plugin
	By neo101
	licensed under a Creative Commons Attribution No-Derivs 2.5 License 
	http://creativecommons.org/licenses/by-nd/2.5/
*************************************************************/


//http://dss1.siteadvisor.com/DSS/MultiQuery?Entitlement=FOO&Type=domain&version=2&client_ver=test&locale=en-US&aff_id=0&Name_1=cnn.com&Name_2=example.com
//http://dss1.siteadvisor.com/DSS/Query?Type=domain&version=2&name=www.w3schools.com

//languages = "en-US","en-CA","en-GB","en-AU","en-IE","es-ES","es-MX","es-AR","es-CL","es-PE","fr-FR","fr-CA",
//"pt-PT","pt-BR","zh-CN","zh-TW","cs-CZ","de-DE","it-IT",
//"ja-JP","nl-NL","nb-NO","no-NO","pl-PL","da-DK","fi-FI","tr-TR","sv-SE","ko-KR"

var SiteAdvisor = {
	singleDomainUrl: 'http://dss1.siteadvisor.com/DSS/Query?Type=domain&version=2&locale=',
	multipleDomainsUrl: 'http://dss1.siteadvisor.com/DSS/MultiQuery?Entitlement=FOO&Type=domain&version=2&client_ver=test&aff_id=0&locale=',
	language: 'en-US'
}


SiteAdvisor.analyzeSingleDomain = function(domain, functionToCall){
	var callBack = {'onFailure': this.onFailure, 'onSuccess': this.onResponseSingleDomain, 'returnXML':true, 'functionToCall':functionToCall}
	var url = this.singleDomainUrl + SiteAdvisor.language + '&name=' + domain
	var number = AjaxLib.openConnection(url, 'get', callBack, null)
	AjaxLib.makeCall( number )
}


SiteAdvisor.analyzeMultipleDomains = function(domains, functionToCall){
	var callBack = {'onFailure': this.onFailure, 'onSuccess': this.onResponseMultipleDomains, 'returnXML':true, 'functionToCall':functionToCall}
	var url = this.createMultipleDomainsUrl(domains)
	var number = AjaxLib.openConnection(url, 'get', callBack, null)
	AjaxLib.makeCall( number )
}


SiteAdvisor.createMultipleDomainsUrl = function(domains){
	var result = this.multipleDomainsUrl + SiteAdvisor.language
	for(var i=0; i<domains.length; i++){
		result += '&Name_' + (i + 1) + '=' + domains[i][0]
	}
	return result
}


SiteAdvisor.onFailure = function(object){
	MaxLib.showError('Connection error ' + object.object.status + ' ' + object.object.statusText);
}


SiteAdvisor.onResponseSingleDomain = function(responseXML, object){
	var xml = responseXML.documentElement
	object.callBack.functionToCall(SiteAdvisor.getDomainObject(xml))
}


SiteAdvisor.onResponseMultipleDomains = function(responseXML, object){
	resultArray = new Array()
	var nodes = responseXML.selectNodes('MultiDomainQueryResponse/DomainQueryResponseArray/DomainQueryResponse')
	for(var i=0; i<nodes.length; i++){
		resultArray.push( SiteAdvisor.getDomainObject(nodes[i]) )
	}
	object.callBack.functionToCall(resultArray)
}


SiteAdvisor.getNode = function(xml, xpath){
	var node = xml.selectSingleNode(xpath)
	if(node){
		return node.text
	}
	return ''
}


SiteAdvisor.getDomainObject = function(xml){
	result = {}
	result.domain = SiteAdvisor.getNode(xml, 'DomainInfo/@name')
	result.domainPopularity = SiteAdvisor.getNode(xml, 'DomainInfo/@popularity')
	result.domainAge = SiteAdvisor.getNode(xml, 'DomainInfo/DomainMetaData/@dateCreated')
	result.domainLocation = SiteAdvisor.getNode(xml, 'DomainInfo/DomainMetaData/Location/@country')
	result.classificationCode = SiteAdvisor.getNode(xml, 'DomainInfo/Classification/@code')
	result.classificationDescription = SiteAdvisor.getNode(xml, 'DomainInfo/Classification/description')
	result.downloadsInfoCode = SiteAdvisor.getNode(xml, 'DomainInfo/FacetInfos/DownloadsInfo/@code')
	result.downloadsInfoDescription = SiteAdvisor.getNode(xml, 'DomainInfo/FacetInfos/DownloadsInfo/description')
	result.downloadsInfoShortDescription = SiteAdvisor.getNode(xml, 'DomainInfo/FacetInfos/DownloadsInfo/short_desc')
	result.personalInfoCode = SiteAdvisor.getNode(xml, 'DomainInfo/FacetInfos/PersonalInformationInfo/@code')
	result.personalInfoDescription = SiteAdvisor.getNode(xml, 'DomainInfo/FacetInfos/PersonalInformationInfo/description')
	result.personalInfoShortDescription = SiteAdvisor.getNode(xml, 'DomainInfo/FacetInfos/PersonalInformationInfo/short_desc')
	result.annoyanceInfoCode = SiteAdvisor.getNode(xml, 'DomainInfo/FacetInfos/AnnoyanceInfo/@code')
	result.annoyanceInfoDescription = SiteAdvisor.getNode(xml, 'DomainInfo/FacetInfos/AnnoyanceInfo/description')
	result.annoyanceInfoShortDescription = SiteAdvisor.getNode(xml, 'DomainInfo/FacetInfos/AnnoyanceInfo/short_desc')
	result.linksInfoCode = SiteAdvisor.getNode(xml, 'DomainInfo/FacetInfos/LinksInfo/@code')
	result.linksInfoDescription = SiteAdvisor.getNode(xml, 'DomainInfo/FacetInfos/LinksInfo/description')
	result.linksInfoShortDescription = SiteAdvisor.getNode(xml, 'DomainInfo/FacetInfos/LinksInfo/short_desc')
	return result
}
