/**************************
	Tooltip Library
	By Neo101
	Version 1.0.0
**************************/


var Tooltip = {
	x : 0,
	y : 0,
	interval : null,
	DELAY_START : 700,
	DELAY_REMOVE : 25000
}


Tooltip.init = function(){
	element = document.createElement('div');
	element.id = 'tooltip'
	element.style.display = 'none'
	document.documentElement.childNodes[1].appendChild(element);
}


Tooltip.setMouseCoords = function() {
	Tooltip.x = event.clientX;
	Tooltip.y = event.clientY;
}


Tooltip.showTooltip = function(text) {
	Tooltip.clearTimeout(Tooltip.interval);
	Tooltip.text = text
	
	Tooltip.interval = window.setTimeout(Tooltip.activateTooltip, Tooltip.DELAY_START);
}


Tooltip.activateTooltip = function() {
	Tooltip.clearTimeout(Tooltip.interval);
	var text = Tooltip.text;
	
	var element = document.getElementById("tooltip")
	if(element == null){
		Tooltip.init()
	}

	text = unescape(text);

	element.innerHTML = text;
	element.style.display = ''
	if(Tooltip.x+element.offsetWidth + 10 > document.body.clientWidth){
		element.style.left = (Tooltip.x-element.offsetWidth + document.body.scrollLeft) + "px";
	} else {
		element.style.left = Tooltip.x + "px";
	}
	//alert(Tooltip.y + '\n' + element.offsetHeight + '\n' + document.body.clientHeight)
	if(Tooltip.y+element.offsetHeight + 10 > document.body.clientHeight){
		element.style.top = Tooltip.y - element.offsetHeight + document.body.scrollTop - 10 + "px";
	} else {
		element.style.top = Tooltip.y + document.body.scrollTop + 20 + "px";
	}
	Tooltip.interval = window.setTimeout(Tooltip.hideTooltip, Tooltip.DELAY_REMOVE);
}


Tooltip.hideTooltip = function() {
	document.getElementById("tooltip").style.display = 'none'
	Tooltip.clearTimeout(Tooltip.interval);
}


Tooltip.clearTimeout = function(interval){
	if(interval){
		window.clearTimeout(interval)
	}
}